package com.sun.jersey.samples.helloworld.resources

import se.scalablesolutions.akka.actor.Actor

import _root_.java.util.Date
import javax.ws.rs.{Produces, GET, Path}

/**
 * A resource bean which uses Scala markup to generate the response , to be used with jersey-scala library
 *
 * @version $Revision: 1.1 $
 */
@Path("/hello/markup")
class MarkupResource extends Actor {
  val name = "James"

  case object Markup

  @Produces(Array("text/html"))
  @GET
  def get() = (this !! Markup).getOrElse("Failed to generate markup")
    

  def receive = {
    case Markup => {
      reply(
        <html>
          <body>
            <h1>Hello {name}</h1>
            <p>Markup generated by Scala code at {new Date()}</p>
            </body>
        </html>
        toString
      )
    }
  }
}
